var sys                     = require('sys'),
    mysql_libmysqlclient    = require("mysql-libmysqlclient");
    
    var MySQLConnection = function (port)
    {
        this.conn = mysql_libmysqlclient.createConnectionSync("localhost", "test", "", "test", port);
        if (!this.conn) {
            console.log(this.conn.connectionError);
            return;
        }
        this.free = true;
        this.port = port;
    };
    
    MySQLConnection.prototype.query = function (queryText, cb)
    {
        var mysqlconn = this;
        this.free = false;
        if (!this.conn.connectedSync()) {
            console.log(this.conn.errorSync());
            return;
        }
        
        this.conn.query(queryText, function (err, res) {
            if (err !== null || res === false) {
                console.log(err.msg);
                return;
            }
            if (typeof res === 'undefined') {
                mysqlconn.free = true;
                if (typeof cb !== 'undefined') {
                    cb();
                }
                return;
            }
            
            if (typeof res.fetchAll === 'undefined') {
                mysqlconn.free = true;
                if (typeof cb !== 'undefined') {
                    cb();
                }
                return;
            }
            
            var cbRes = function (err, rows)
            {
                res.freeSync();
                if (err !== null) {
                    console.log(err.msg);
                    return;
                }
                mysqlconn.free = true;
                if (typeof cb !== 'undefined') {
                    cb(rows);
                }
            }
            res.fetchAll(cbRes);
        });
    };
    
    var MySQLManager = function (port, count)
    {
        this.connections = [];
        for (var i = 0; i < count; ++i) {
            this.connections.push(new MySQLConnection(port));
        }
        this.lastConnIndex = 0;
    };
    
    MySQLManager.prototype.getFreeConection = function ()
    {
        var i = (this.lastConnIndex + 1) % this.connections.length;
        while(i !== this.lastConnIndex) {
            if (this.connections[i].free) {
                this.lastConnIndex = i;
                return this.connections[this.lastConnIndex];
            }
            ++i;
            i %= this.connections.length;
        }
        return null;
    };
    
    MySQLManager.prototype.query = function (queryText, cb)
    {
        var con = this.getFreeConection();
        if (con !== null) {
            con.query(queryText, cb);
        } else {
            var mysql = this;
            process.nextTick(function ()
            {
                mysql.query(queryText, cb);
            });
        }
    };

exports.MySQLManager = MySQLManager;
