var app     = require('app');

var profiler = require('v8-profiler');

var MyObject = function (i)
{
    this.buffer = [];
    this.lastBuffer = [];
    this.start1();
    this.start2();
    
    if (i == 0) {
        profiler.takeSnapshot(Date.now());
        
        var self = this;
        setInterval(function () {
            console.log("lengths = " + self.buffer.length + ", " + self.lastBuffer.length);
            console.log(process.memoryUsage());
            profiler.takeSnapshot(Date.now());
        }, 30000);
    }
};

MyObject.prototype.start1 = function ()
{
    var obj = this;
    setInterval(function ()
    {
        var queryText = "SELECT * from test_table3 LIMIT 16;";
        app.sqlmanager.query(queryText, function (rows) {
            rows.forEach(function (row) {
                obj.buffer.push(row.id);
            });
        });
    }, 500);
};

MyObject.prototype.start2 = function ()
{
    var obj = this;
    setInterval(function ()
    {
        if (obj.buffer.length === 0) {
            return;
        }
        while (obj.buffer.length !== 0) {
            obj.lastBuffer.push(obj.buffer.shift());
        }
        obj.lastBuffer = null;
        obj.buffer = null;
        obj.lastBuffer = [];
        obj.buffer = [];
    }, 30);
    this.start1 = null;
};

exports.MyObject = MyObject;
